"use strict";
this.name				= "Emergency Docking Clearance";
this.author				= "Stranger";
this.copyright			= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description		= "Override docking delays";
this.version			= "1.1";

this.$waitingLimit = 15; // max 15 min

this.shipWillLaunchFromStation = this.shipEnteredStationAegis = function()
	{
	if(system.isInterstellarSpace || !system.mainStation.isValid)
		{ return; }
	system.mainStation.requiresDockingClearance = true;
	this.$waitingCounter = 0;
    this.$waitingTime = this.$waitingLimit;
	}
    
this.shipWillDockWithStation = this.shipWillEnterWitchspace = this.shipExitedStationAegis = function()
	{
    this.shipDied();
    }

this.$setClearance = function()
	{
	if(!system.mainStation || player.dockingClearanceStatus == "DOCKING_CLEARANCE_STATUS_GRANTED")
		{
		this.shipDied();
		return; 
		}
    this.$waitingCounter += 1;
    var message;
    if (this.$waitingCounter >= 60)
        {
        if (system.mainStation.alertCondition == 3)
            {
            message = "Emergency docking frozen";
            }
        else
            {
            this.$waitingTime -= 1;
            if (this.$waitingTime > 0 && player.ship.aftShield >= 0.1 * player.ship.maxAftShield)
                {
                message = "Emergency docking in " + this.$waitingTime + " min";
                }
            else
                {
                system.mainStation.requiresDockingClearance = false;
                message = "Emergency docking allowed";            
                }
            }
        player.consoleMessage("\n\n\n\n\n\n\n\n\n\n Docking clearance status: " + message,5);
        this.$waitingCounter -= 60;
        }
	}

this.shipDied = function()
	{
	if(this.$dockTimer) 
		{
		this.$dockTimer.stop();
		delete this.$dockTimer;
		}
	}

this.playerRequestedDockingClearance = function(message)
    {
    if (player.ship.target != system.mainStation || player.bounty > 50 || system.mainStation.alertCondition == 3)
        { return; }
    if (player.ship.aftShield < 0.1 * player.ship.maxAftShield) // shields possibly shut down
        {
        system.mainStation.requiresDockingClearance = false;
        }
    else
        {
        if (!this.$dockTimer)
            {
            this.$dockTimer = new Timer(this, this.$setClearance, 0, 1);
            }
        }
    }